#include "StdAfx.h"
#include "resource.h"
#include "TabDlg0.h"

TabDlg0* pTabDlg0;

TabDlg0::TabDlg0(void)
{
	pTabDlg0=this;
}

TabDlg0::~TabDlg0(void)
{
	CsvDataWrite();
	DestroyWindow(hTabDlg0);
	RemoveProp(hTabDlg0,"TabDlg0");
}

HWND TabDlg0::Create(HINSTANCE hInstance,HWND hWnd)
{
	hInst=hInstance;
	hParent=hWnd;
	hTabDlg0=CreateDialog(hInst,MAKEINTRESOURCE(IDD_TABDLG0),hParent,(DLGPROC)TabDlg0Proc);
	if(hTabDlg0==NULL)
		return FALSE;

	SetProp(hTabDlg0,"TabDlg0",this);

	hList=GetDlgItem(hTabDlg0,IDC_LIST2);

	SetList(hTabDlg0);
	CsvDataRead();
	MonitorDataSet();

	UpdateWindow(hTabDlg0);

	return hTabDlg0;
}

BOOL TabDlg0::SetList(HWND hTabDlg0)
{
	char* colname[]={"Dev","oDev","ON","OFF"};
	int width[]={70,70,50,50};

	DWORD dwStyle;
	dwStyle=ListView_GetExtendedListViewStyle(hList);
	dwStyle |= LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES;
	ListView_SetExtendedListViewStyle(hList,dwStyle);

	LV_COLUMN lvc;
	memset(&lvc,'\0',sizeof(LV_COLUMN));
	lvc.mask=LVCF_FMT | LVCF_WIDTH | LVCF_TEXT;
	lvc.fmt=LVCFMT_LEFT;
	for(int i=0 ; i<4 ; i++)
	{
		lvc.cchTextMax=sizeof(colname[i]);
		lvc.pszText=colname[i];
		lvc.cx=width[i];
		ListView_InsertColumn(hList,i,&lvc);
	}
	return TRUE;
}

VOID TabDlg0::CsvDataRead()
{
	int i=0;
	int col=0;
	std::string device[4];

	std::ifstream ifs("DevSet.csv");
	if(!ifs)
		return;

	std::string csvdata="";
	LV_ITEM item;
	item.mask=LVIF_TEXT;
	item.iSubItem=0;

	while(std::getline(ifs,csvdata))
	{
		std::string devdata="";
		std::istringstream stream(csvdata);
		while(getline(stream,devdata,','))
		{
			device[i]=devdata;
			if(i==0)
			{
				item.pszText=(LPSTR)device[0].c_str();
				item.iItem=col;
				item.iSubItem=0;
				ListView_InsertItem(hList,&item);
			}
			else
			{
				item.pszText=(LPSTR)device[i].c_str();
				item.iItem=col;
				item.iSubItem=i;
				ListView_SetItem(hList,&item);
			}
			i++;
		}
		i=0;
		col++;
	}
}


VOID TabDlg0::CsvDataWrite()
{
	std::ofstream ofs("DevSet.csv");
	int iCount=ListView_GetItemCount(hList);
	DWORD dwSize=16;
	char* pszBuf=new char[dwSize];

	for(int i=0 ; i<iCount ; i++)
	{
		ListView_GetItemText(hList,i,0,pszBuf,dwSize);
		ofs<<pszBuf<<",";
		ListView_GetItemText(hList,i,1,pszBuf,dwSize);
		ofs<<pszBuf<<",";
		ListView_GetItemText(hList,i,2,pszBuf,dwSize);
		ofs<<pszBuf<<",";
		ListView_GetItemText(hList,i,3,pszBuf,dwSize);
		ofs<<pszBuf<<std::endl;
	}

	delete[] pszBuf;
}

VOID TabDlg0::SetEdit()
{
	static long prevpos=-1;
	HWND hEdit1=GetDlgItem(hTabDlg0,IDC_EDIT1);
	HWND hEdit2=GetDlgItem(hTabDlg0,IDC_EDIT2);
	HWND hEdit3=GetDlgItem(hTabDlg0,IDC_EDIT3);
	HWND hEdit4=GetDlgItem(hTabDlg0,IDC_EDIT4);
	long pos=ListView_GetNextItem(hList,-1,LVNI_SELECTED);
	if(pos<0 || pos==prevpos)
		return;
	else
		prevpos=pos;

	DWORD dwSize=16;
	char* pszBuf=new char[dwSize];

	ListView_GetItemText(hList,pos,0,pszBuf,dwSize);
	SetWindowText(hEdit1,pszBuf);
	ListView_GetItemText(hList,pos,1,pszBuf,dwSize);
	SetWindowText(hEdit2,pszBuf);
	ListView_GetItemText(hList,pos,2,pszBuf,dwSize);
	SetWindowText(hEdit3,pszBuf);
	ListView_GetItemText(hList,pos,3,pszBuf,dwSize);
	SetWindowText(hEdit4,pszBuf);

	delete pszBuf;
}

VOID TabDlg0::DeleteList()
{
	long pos=ListView_GetNextItem(hList,-1,LVNI_SELECTED);
	if(pos==-1)
		return;

	ListView_DeleteItem(hList,pos);
	MonitorDataSet();
}

VOID TabDlg0::AddList()
{
	HWND hEdit1=GetDlgItem(hTabDlg0,IDC_EDIT1);
	HWND hEdit2=GetDlgItem(hTabDlg0,IDC_EDIT2);
	HWND hEdit3=GetDlgItem(hTabDlg0,IDC_EDIT3);
	HWND hEdit4=GetDlgItem(hTabDlg0,IDC_EDIT4);

	int iCount=ListView_GetItemCount(hList);

	DWORD dwSize=16;
	char* device=new char[dwSize];
	LV_ITEM item;
	item.mask=LVIF_TEXT;

	GetWindowText(hEdit1,device,dwSize);

	if(strcmp(device,"")==0)
		return;

	item.pszText=device;
	item.iItem=iCount;
	item.iSubItem=0;
	ListView_InsertItem(hList,&item);

	GetWindowText(hEdit2,device,dwSize);
	ListView_SetItemText(hList,iCount,1,device);

	GetWindowText(hEdit3,device,dwSize);
	ListView_SetItemText(hList,iCount,2,device);

	GetWindowText(hEdit4,device,dwSize);
	ListView_SetItemText(hList,iCount,3,device);

	MonitorDataSet();
	delete device;
}

VOID TabDlg0::MonitorDataSet()
{
	int iCount=ListView_GetItemCount(hList);
	char* pszBuf=new char[12];
	MonitorData bufdata;
	strMonitorData.erase(strMonitorData.begin(),strMonitorData.end());
	for(int i=0 ; i<iCount ; i++)
	{
		ListView_GetItemText(hList,i,0,pszBuf,12);
		strncpy_s(bufdata.readDev,12,pszBuf,12);
		ListView_GetItemText(hList,i,1,pszBuf,12);
		strncpy_s(bufdata.writeDev,12,pszBuf,12);
		ListView_GetItemText(hList,i,2,pszBuf,12);
		bufdata.onData=atol(pszBuf);
		ListView_GetItemText(hList,i,3,pszBuf,12);
		bufdata.offData=atol(pszBuf);
		strMonitorData.push_back(bufdata);
	}
	SendMessage(hParent,WM_MONMSG,(WPARAM)0,(LPARAM)0);
}


//Devݒɓ͂foCX̗L
VOID TabDlg0::DevSerch()
{
	LVFINDINFO info;
	int nIndex;
	char device[16];

	HWND hEdit1=GetDlgItem(hTabDlg0,IDC_EDIT1);
	GetWindowText(hEdit1,device,16);

	if(strcmp(device,"")==0)
		return;

	info.flags=LVFI_PARTIAL | LVFI_STRING;
	info.psz=device;
	nIndex=ListView_FindItem(hList,-1,&info);
	if(nIndex==-1)
		return;

	ListView_SetItemState(hList,nIndex,LVIS_SELECTED,LVIS_SELECTED);
	ListView_EnsureVisible(hList,nIndex,TRUE);
}

BOOL TabDlg0::TabDlg0Message(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	NMHDR* pnmh;
	switch(msg)
	{
	case WM_COMMAND:
		switch(wParam)
		{
		case IDC_SET:
			AddList();
			return TRUE;
		case IDC_DELETE:
			DeleteList();
			return TRUE;
		case IDC_BUTTON1:
			DevSerch();
			return TRUE;
		}
		break;
	case WM_NOTIFY:
		if(wParam==IDC_LIST2)
		{
			pnmh=(LPNMHDR)lParam;
			if(pnmh->code==LVN_ITEMCHANGED)
			{
				SetEdit();
			}
			return TRUE;
		}
		break;
	}
	return FALSE;
}

//**************************************************************
//bZ[vV[W
//**************************************************************
BOOL CALLBACK TabDlg0Proc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	TabDlg0* pdlg=(TabDlg0*)GetProp(hwnd,"TabDlg0");

	if(pdlg==NULL)
		return FALSE;

	return pdlg->TabDlg0Message(hwnd,msg,wParam,lParam);
}
