#include "StdAfx.h"
#include "MXComp.h"
#include "cThread.h"


cThread::cThread(HWND hwnd)
{
	m_hParent=hwnd;
	m_hThreadKill=CreateEvent(NULL,TRUE,FALSE,_T("NThreadKill"));
	m_hRead=CreateEvent(NULL,TRUE,FALSE,_T("NRead"));
	m_hWrite=CreateEvent(NULL,TRUE,FALSE,_T("NWrite"));
	m_hMonitor=CreateEvent(NULL,TRUE,FALSE,_T("NMonitor"));
}


cThread::~cThread(void)
{
	ResetEvent(m_hThreadKill);
	ResetEvent(m_hMonitor);
	CloseHandle(m_hThread);
	CloseHandle(m_hThreadKill);
	CloseHandle(m_hRead);
	CloseHandle(m_hWrite);
	CloseHandle(m_hMonitor);
}


void cThread::Run()	//Xbh̋N
{
	m_hThread=(HANDLE)_beginthreadex(NULL,0,ThreadRun,this,0,NULL);
}

BOOL cThread::Close() //XbhN[YicThread폜OɌĂ)
{
	SetEvent(m_hThreadKill);
	WaitForSingleObject(m_hThread,INFINITE);

	return TRUE;
}

//staticȂ̂ŕ̃Xbhł֐Ă΂邱ƂɂȂ
unsigned cThread::ThreadRun(void* param)
{
	cThread* pParam=(cThread*)param;

	MXComp m_MXComp;
	if(m_MXComp.Create()==FALSE)
		return 0;

	if(m_MXComp.Open(pParam->StationNo)==FALSE)
	{
		PostMessage(pParam->m_hParent,WM_THREADMSG,0,1);
		return 0;
	}
	else
		PostMessage(pParam->m_hParent,WM_THREADMSG,1,1);
	
	const char* dev;
	int count=0;
	int forcecount=0;
	long val;
	long readVal[256];
	long writeVal;
	long forceVal[16];

	
	while(WaitForSingleObject(pParam->m_hThreadKill,1)==WAIT_TIMEOUT)
	{
		//o
		if(WaitForSingleObject(pParam->m_hWrite,0)==WAIT_OBJECT_0)
		{
			dev=pParam->writeDevice.c_str();
			m_MXComp.SetDevice((LPSTR)dev,pParam->writeVal);
			ResetEvent(pParam->m_hWrite);
		}

		//j^[
		if(WaitForSingleObject(pParam->m_hMonitor,0)==WAIT_OBJECT_0)
		{
			if(count>(int)pParam->strMoniData.size()-1)
				count=0;

			try
			{
				m_MXComp.GetDevice(pParam->strMoniData[count].readDev,&val);
			}
			catch(...)
			{
				MessageBox(pParam->m_hParent,_T("ُ픭"),_T("ERR"),MB_OK);
				break;
			}

			if(readVal[count] != val)
			{
				readVal[count]=val;

				if(val>0)
					writeVal=pParam->strMoniData[count].onData;
				else
					writeVal=pParam->strMoniData[count].offData;

				if(writeVal != -1)
				{
					if(m_MXComp.SetDevice(pParam->strMoniData[count].writeDev,writeVal)==FALSE)
						MessageBox(pParam->m_hParent,_T("Ȃ"),_T("ERR"),MB_OK);
				}
			}
			count++;
		}
		else //ǏoLNA
		{
			for(int i=0 ; i<256 ; i++)
				readVal[i]=-1;
		}

		//o͂̃j^[
		if(strcmp(pParam->forceDev[forcecount],"") != 0)
		{
			m_MXComp.GetDevice(pParam->forceDev[forcecount],&val);
			//ŕ\
			if(forceVal[forcecount] != val)
			{
				forceVal[forcecount]=val;
				if(val > 0)
					PostMessage(pParam->m_hParent,WM_THREADMSG,forcecount,2);
				else
					PostMessage(pParam->m_hParent,WM_THREADMSG,forcecount,3);
			}
		}
		forcecount++;
		if(forcecount>15) forcecount=0;
	}
	return 0;
}

